function graph_Mslice(handle)
%
%GRAPH_MSLICE
%
%       Graph the data in the slice mode.
%

global ParsecData WFNData PguiData pvoxMslice;

axes(handle);

x_sli = WFNData.X(1,pvoxMslice.x);
y_sli = WFNData.X(1,pvoxMslice.y);
z_sli = WFNData.X(1,pvoxMslice.z);

if ( PguiData.draw_mode == 1 )
    set(handle, 'DrawMode', 'normal');
else
    set(handle, 'DrawMode', 'fast');
end

%graph data
switch ( PguiData.graph )
    case 'wfn'
        g1 = slice(WFNData.X, WFNData.Y, WFNData.Z, WFNData.wfn(:,:,:,pvoxMslice.level), x_sli, y_sli, z_sli);
    case 'pot'
        g1 = slice(WFNData.X, WFNData.Y, WFNData.Z, WFNData.pot(:,:,:), x_sli, y_sli, z_sli);
    case 'rho'
        g1 = slice(WFNData.X, WFNData.Y, WFNData.Z, WFNData.rho(:,:,:), x_sli, y_sli, z_sli);
end

set(g1, 'FaceColor', 'interp');

%use preferences
if ( PguiData.gridlines == 0 )
    set (g1,'EdgeColor', 'none');
end

if ( PguiData.atoms )
    plot_atoms;
end

colormap(PguiData.colormap);
if ( PguiData.colormap_invert )
    cm = colormap;
    s = size(cm(:,1));
    s = s(1);
    for ( i = 1:s )
        cm2(i,:) = cm(s-i+1,:);
    end
    colormap(cm2);
end

if ( PguiData.draw_mode == 1 )
    set(handle, 'DrawMode', 'normal');
else
    set(handle, 'DrawMode', 'fast');
end
