function plot_atoms(varargin)
%
%PLOT_ATOMS
%
%       Add the atoms to the current plot
%

global ParsecData WFNData PguiData

X = ParsecData.forceTotal(:,1);
Y = ParsecData.forceTotal(:,2);
Z = ParsecData.forceTotal(:,3);

hold on

type = 1;
offset = 0;
[xx, yy, zz] = sphere(10);

%
%for each atom of every type, plot a sphere 
%of the correct size and color centered in the correct spot, 
%and adjust the gridlines
%
while ( type <= ParsecData.numTypes )
    
    for ( m = 1:ParsecData.typeNum(type) )
        xx2 = (xx .* .5*ParsecData.typeSize(type)) + X(m+offset);
        yy2 = (yy .* .5*ParsecData.typeSize(type)) + Y(m+offset);
        zz2 = (zz .* .5*ParsecData.typeSize(type)) + Z(m+offset);
        s = surf(xx2, yy2, zz2);
        set(s, 'FaceColor', ParsecData.typeColor(type,:));
        if ( PguiData.gridlines == 0 )
            set (s,'EdgeColor', 'none');
        end
    end
    offset = offset + ParsecData.typeNum(type);
    type = type+1;
end

hold off
