## WFNREAD.PY - Reads binary wfn.dat from parsec ##
import array, sys

## OPEN parsec.out file ##
fname = file('./pTemp/fname.dat', 'r')
fileName = fname.readline()
fileName = fname.readline()
switchEndian = fname.readline()
switchEndian = int(switchEndian)
fname.close()
fileName = fileName.rstrip('\n')
inFile = file(fileName, 'rb')

## OPEN output files ##
outFile1 = file('./pTemp/wfn1.out', 'w')
outFile2 = file('./pTemp/wfn2.out', 'w')
outFile3 = file('./pTemp/wfn3.out', 'w')
outFile = outFile1

## CREATE arrays for storage ##
prefix = array.array('L')   # Stores Fortran prefix
DATE = array.array('c')     # Stores the DATE
INT = array.array('l')      # Stores integers
DOUBLE = array.array('d')   # Stores doubles
TRASH = array.array('L')    # Holds data not used

## GETPREFIX(): Reads in the prefix to a data block and returns its value ##
def getPREFIX():
    prefix.fromfile(inFile,1)
    if (switchEndian):
        prefix.byteswap()
    return prefix[len(prefix)-1]

## GETINT(): Reads a sequence of integers. Returns the number of integers read into INT ##
def getINT():
    length = getPREFIX()
    INT.fromfile(inFile,length/4)
    if (switchEndian):
       INT.byteswap()
    if (length != getPREFIX()):
        print "ERROR: Unexepected value read in getINT()\n"
        inFile.close()
        outFile.close()
        sys.exit()
    return length/4

## GETDOUBLE(): Reads a sequence of doubles. Returns the number of doubles read into DOUBLE ##
def getDOUBLE():
    length = getPREFIX()
    DOUBLE.fromfile(inFile,length/8)
    if (switchEndian):
       DOUBLE.byteswap()
    if (length != getPREFIX()):
        print "ERROR: Unexepected value read in getDOUBLE()\n"
        inFile.close()
        outFile.close()
        sys.exit()
    return length/8

def writeINT(n):
    for x in range(0,n):
        outFile.write(str(INT[len(INT)-(n-x)]))
        outFile.write(" ")
    outFile.write("\n")

def writeDOUBLE(n):
    for x in range(0,n):
        outFile.write(str(DOUBLE[len(DOUBLE)-(n-x)]))
        outFile.write(" ")
    outFile.write("\n")
        

## DATE ##    
i = getPREFIX()
DATE.fromfile(inFile,i)
for n in range(0,i):
    outFile.write(DATE[n])
outFile.write("\n")
getPREFIX()

## (grid%Step, grid%rmax, grid%ndim, grid%nwedge, i_1, i_1) ##
getPREFIX()
DOUBLE.fromfile(inFile,2)
if (switchEndian):
   DOUBLE.byteswap()
INT.fromfile(inFile,4)
if (switchEndian):
   INT.byteswap()
outFile.write("%f %f %i %i %i %i\n" % (DOUBLE[0], DOUBLE[1], INT[0], INT[1], INT[2], INT[3])) 
getPREFIX()

## (grid%shift) ##
n = getDOUBLE()
writeDOUBLE(n)

## (i_1,kk=1,9) ##
n = getINT()
writeINT(n)

## (one,kk=1,9) ##
n = getDOUBLE()
writeDOUBLE(n)

## (one,kk=1,3) ##
n = getDOUBLE()
writeDOUBLE(n)

## (zero,kk=1,9*3) ##
n = getDOUBLE()
writeDOUBLE(n)

## (i_1) ##
n = getINT()
writeINT(n)

## (grid%kx(kk), grid%ky(kk), grid%kz(kk), kk=1, grid%nwedge) ##
outFile = outFile2
n = getINT()
writeINT(n)

## (nstate) ##
outFile = outFile1
n = getINT()
writeINT(n)

## (i_1,kk=1,nstate) ##
n = getINT()
writeINT(n)

## (en_tmp(kk),kk=1,nstate) ##
n = getDOUBLE()
writeDOUBLE(n)

## (occ_tmp(kk),kk=1,nstate) ##
nstate = getDOUBLE()
writeDOUBLE(nstate)
    
## (pot%vnew(kk,1),kk=1,grid%nwedge) ##
outFile = outFile3
n = getDOUBLE()
writeDOUBLE(n)

## (elec_st%rho(kk,1),kk=1,grid%nwedge) ##
n = getDOUBLE()
writeDOUBLE(n)

## do kk=1,nstate (elec_st%eig(1,1)%wf(jj,kk),jj=1,grid%nwedge) ##
for i in range (0, nstate):
    n = getDOUBLE()
    writeDOUBLE(n)

inFile.close()
outFile1.close()
outFile2.close()
outFile3.close()


######################## wfnsave.f #################################
#      rewind(4)                                                   #
#      call date_time(datelabel,tmpd)                              #
#                                                                  #
#      write(4) datelabel                                          #
#      write(4) grid%step(1), grid%rmax                            #
#     1     ,grid%ndim,grid%nwedge,i_1,i_1                         #
#      write(4) grid%shift                                         #
#      write(4) (i_1,kk=1,9)                                       #
#      write(4) (one,kk=1,9)                                       #
#      write(4) (one,kk=1,3)                                       #
#      write(4) (zero,kk=1,9*3)                                    #
#      write(4) i_1                                                #
#      write(4) (grid%kx(kk),grid%ky(kk),grid%kz(kk),              #
#     1     kk=1,grid%nwedge)                                      #
#      nstate = elec_st%nstate                                     #
#      allocate(en_tmp(nstate))                                    #
#      allocate(occ_tmp(nstate))                                   #
#      do kk = 1, nstate                                           #
#         en_tmp(kk) = elec_st%eig(1,1)%en(kk)                     #
#         occ_tmp(kk) = elec_st%eig(1,1)%occ(kk)                   #
#      enddo                                                       #
#      write(4) nstate                                             #
#      write(4) (i_1,kk=1,nstate)                                  #
#      write(4) (en_tmp(kk),kk=1,nstate)                           #
#      write(4) (occ_tmp(kk),kk=1,nstate)                          #
#      deallocate(en_tmp, occ_tmp)                                 #
#                                                                  #
#      write(4) (pot%vnew(kk,1),kk=1,grid%nwedge)                  #
#      write(4) (elec_st%rho(kk,1),kk=1,grid%nwedge)               #
#                                                                  #
#      do kk=1,nstate                                              #
#         node = 0                                                 #
#         lstart = parallel%Irows(node)                            #
#         ldim = parallel%Irows(node+1) - lstart                   #
#         write(4) (elec_st%eig(1,1)%wf(jj,kk),jj=1,grid%nwedge)   #
#      enddo                                                       #
#                                                                  #
#      call myflush(4)                                             #
####################################################################
