function [wfn, pot, rho, wavedata] = wfnread_rsdft(fileName)
%
%WFNREAD_RSDFT
%
%       reads wfn.dat from rsdft
%
%
myFile = fopen(fileName,'r', 'l');

% Determine (big/little)-endian
prefix = fread(myFile, 1, 'uint32');
if (prefix > 100)
    fclose(myFile);
    myFile = fopen(fileName,'r', 'b');
    prefix = fread(myFile, 1, 'uint32');
end

%read in radius and step size
wfn.radius = fread(myFile, 1, 'uint32');
wfn.step = fread(myFile, 1, 'double');
wfn.first_state = 1;

%read in pot_length & pot
pot_length = fread(myFile, 1, 'uint32');
pot = fread(myFile, pot_length, 'double');

%read in rho_length & rho
rho_length = fread(myFile, 1, 'uint32');
rho = fread(myFile, rho_length, 'double');

%read in w_length & wavedata
wfn.num_wedges = fread(myFile, 1, 'uint32');
wfn.num_states = fread(myFile, 1, 'uint32');

if (wfn.num_states > 35)
    global tmp_states first_tmp;
    tmp_states = wfn.num_states;
    uiwait(wfn_warning);
    wfn.first_state = first_tmp;
    wfn.num_states = tmp_states;
    clear global tmp_states first_tmp
end

wavedata = zeros(wfn.num_wedges, wfn.num_states);
for i = 1:wfn.num_states
  wavedata(:,i) = fread(myFile, wfn.num_wedges, 'double');
end
fclose(myFile);
%{
%%__________________________________
myfile = fopen(fileName,'r');
ps = fopen('phsaw.txt','w');

%read in radius and step size
wfn.radius = str2num(fgetl(myfile));
wfn.step = str2num(fgetl(myfile));
wfn.first_state = 1;

%read in pot_length & pot
pot_length = str2num(fgetl(myfile));
disp(pot_length);
for i=1:pot_length
  pot(i) = str2num(fgetl(myfile));
end

%read in rho_length & rho
rho_length = str2num(fgetl(myfile));
disp(rho_length);
for i=1:rho_length
  rho(i) = str2num(fgetl(myfile));
end
disp('rho');

%read in w_length & wavedata
wfn.num_wedges = str2num(fgetl(myfile));
wfn.num_states = str2num(fgetl(myfile));

if (wfn.num_states > 35)
    global tmp_states first_tmp;
    tmp_states = wfn.num_states;
    uiwait(wfn_warning);
    wfn.first_state = first_tmp;
    wfn.num_states = tmp_states;
    clear global tmp_states first_tmp
end

wavedata = zeros(wfn.num_wedges, wfn.num_states);
disp(wfn.num_wedges);
disp(wfn.num_states);
for i = 1:wfn.num_wedges
  for j = 1:wfn.num_states
    wavedata(i,j) = str2num(fgetl(myfile));
    fprintf(ps, '%e ', wavedata(i,j));
  end
  fprintf(ps, '\n');
end
disp('wavy');

fclose(myfile);
fclose(ps);
%}